# Editor

The heart of the editor is [CodeMirror for quite a few reasons][codemirror]. It greatly decrease our barrier to entry. A great thing is that we have it configured in *sublime text* mode.

> Imitation is the sincerest form of flattery

* [Sublime](#sublime)
* [Seamless external editing](#disk-watching)
* [Editing First](#focus)
* [Jumpy](#jumpy)
* [Cursor History](#cursor-history)
* [Clipboard Ring](#clipboard-ring)
* [Blaster](#blaster)

> Note: At any time you press `Esc` we take you to the editor. After all that is the ❤️ of your design.

## Sublime

Sublime users will feel right at home as they get to use all their favorite features as it is e.g. `Ctrl|⌘ + P` (find file), `Ctrl|⌘ + Shift + P` (find command), `Ctrl|⌘ + /` (comment uncomment code), `Ctrl|⌘ + D` (select next match) and even `Alt + Shift + ⇅` for column selection   

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/rectangular.gif)

## Disk Watching
> The file on disk will set you free

You can use this side by side with your favorite editor.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/seemlessExternalEditing.gif)

## Focus
No matter where you are, `esc` will always take you to the currently focused editor, so you can do what you do best, **write code**.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/esc.gif)

## Jumpy
Just press `Ctrl|⌘ + enter` and you can jump anywhere in the current editor.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/jumpy.gif)

## Cursor History
Your cursor history is preserved across all open files. `Ctrl|⌘ + U` and `Ctrl|⌘ + Shift + U`.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/cursorHistory.gif)

## Clipboard Ring
You can cycle paste through the stuff that you copied / cut from the IDE. `Shift + Ctrl|⌘ + V`. Don't lose your head due to a nasty cut/copy error.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/clipboardRing.gif)

## Blaster
Because why not. `Ctrl|⌘ + Shift + O` to toggle.

![](https://raw.githubusercontent.com/alm-tools/alm-tools.github.io/master/screens/blaster.gif)


[codemirror]:../contributing/codemirror.md
